#include "matrix.hpp"
#include "../complex-numbers/cnumber.hpp"
#include "../vectors/vector.hpp"

int main() {
  vector a = vector(3);
  a[0] = cnumber(7, 0);
  a[1] = cnumber(5, 0);
  a[2] = cnumber(0, 1);

  vector b = vector(3);
  b[0] = cnumber(0, 0);
  b[1] = cnumber(2, 0);
  b[2] = cnumber(0, 0);

  vector c = vector(3);
  c[0] = cnumber(0, -1);
  c[1] = cnumber(0, 0);
  c[2] = cnumber(4, 0);

  matrix m = matrix(3, 3);
  m[0] = a;
  m[1] = b;
  m[2] = c;

  cout << "The matrix m:" << endl;
  cout << m << endl;
  cout << "The matrix m's transpose:" << endl;
  cout << m.transpose() << endl;
  if  (!m.is_hermitian()) {
    cout << "The matrix m is not hermitian, here is the hermitian conjugate:"
         << endl;
    cout << m.hermitian_conjugate() << endl;
  }
  return 0;
}
